package xyz.lychee.lagfixer.libs.adventure.text;

import java.util.List;
import java.util.Objects;
import xyz.lychee.lagfixer.libs.adventure.text.format.Style;
import xyz.lychee.lagfixer.libs.annotations.NotNull;
import xyz.lychee.lagfixer.libs.annotations.Nullable;

abstract class NBTComponentImpl<C extends NBTComponent<C, B>, B extends NBTComponentBuilder<C, B>> extends AbstractComponent implements NBTComponent<C, B> {
   static final boolean INTERPRET_DEFAULT = false;
   final String nbtPath;
   final boolean interpret;
   final @Nullable Component separator;

   NBTComponentImpl(final @NotNull List<Component> children, final @NotNull Style style, final String nbtPath, final boolean interpret, final @Nullable Component separator) {
      super(children, style);
      this.nbtPath = nbtPath;
      this.interpret = interpret;
      this.separator = separator;
   }

   public @NotNull String nbtPath() {
      return this.nbtPath;
   }

   public boolean interpret() {
      return this.interpret;
   }

   public boolean equals(final @Nullable Object other) {
      if (this == other) {
         return true;
      } else if (!(other instanceof NBTComponent)) {
         return false;
      } else if (!super.equals(other)) {
         return false;
      } else {
         NBTComponent<?, ?> that = (NBTComponent)other;
         return Objects.equals(this.nbtPath, that.nbtPath()) && this.interpret == that.interpret() && Objects.equals(this.separator, that.separator());
      }
   }

   public int hashCode() {
      int result = super.hashCode();
      result = 31 * result + this.nbtPath.hashCode();
      result = 31 * result + Boolean.hashCode(this.interpret);
      result = 31 * result + Objects.hashCode(this.separator);
      return result;
   }
}
